#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

// The only way to create a new process is via fork(), which duplicates
// the current process. Parent and child are initially identical except
// for their process identifier and the return value of fork().

int main ()
{
	// get an initial value of x for both parent and child
	int x;
	printf("x = "); fflush(stdout);
	scanf("%d",&x);

	int y = fork();

	if (y) {
		// parent: return value of fork() is non-zero, contains child id
		while (1) { sleep(2); printf("[parent] hello %d\n",x++); }
	} else {
		// child: return value of fork() is zero
		while (1) { sleep(5); printf("[child] world %d\n",x++); }
	}
}
